#!/usr/bin/python
#coding: utf-8
 
import smbus
import time
import datetime # datetimeモジュールのインポート
import locale   # import文はどこに書いてもOK(可読性などの為、慣例でコードの始め の方)
import RPi.GPIO as GPIO

RELAY1=20
RELAY2=21
GPIO.setwarnings(False)
GPIO.setmode(GPIO.BCM) # GPIO NUMBER
GPIO.setup(RELAY1,GPIO.OUT)
GPIO.setup(RELAY2,GPIO.OUT)
GPIO.output(RELAY1,GPIO.LOW)
GPIO.output(RELAY2,GPIO.LOW)


# # today()メソッドで現在日付・時刻のdatetime型データの変数を取得
d = datetime.datetime.today()
#   ↑モジュール名.クラス名.メソッド名
 
bus_number  = 1
i2c_address = 0x27
 
bus = smbus.SMBus(bus_number)
 

timestamp = 0 # 時刻


# Define some device parameters
I2C_ADDR  = 0x27 # I2C device address, if any error, change this address to 0x27
LCD_WIDTH = 20 # Maximum characters per line

# Define some device constants
LCD_CHR = 1 # Mode - Sending data
LCD_CMD = 0 # Mode - Sending command

LCD_LINE_1 = 0x80 # LCD RAM address for the 1st line
LCD_LINE_2 = 0xC0 # LCD RAM address for the 2nd line
LCD_LINE_3 = 0x94 # LCD RAM address for the 3rd line
LCD_LINE_4 = 0xD4 # LCD RAM address for the 4th line

LCD_BACKLIGHT  = 0x08  # On
#LCD_BACKLIGHT = 0x00  # Off

ENABLE = 0b00000100 # Enable bit

# Timing constants
E_PULSE = 0.0005
E_DELAY = 0.0005

#Open I2C interface
#bus = smbus.SMBus(0)  # Rev 1 Pi uses 0
bus = smbus.SMBus(1) # Rev 2 Pi uses 1
 
def lcd_init():
  # Initialise display
  lcd_byte(0x33,LCD_CMD) # 110011 Initialise
  lcd_byte(0x32,LCD_CMD) # 110010 Initialise
  lcd_byte(0x06,LCD_CMD) # 000110 Cursor move direction
  lcd_byte(0x0C,LCD_CMD) # 001100 Display On,Cursor Off, Blink Off 
  lcd_byte(0x28,LCD_CMD) # 101000 Data length, number of lines, font size
  lcd_byte(0x01,LCD_CMD) # 000001 Clear display
  time.sleep(E_DELAY)

def lcd_byte(bits, mode):
  # Send byte to data pins
  # bits = the data
  # mode = 1 for data
  #        0 for command

  bits_high = mode | (bits & 0xF0) | LCD_BACKLIGHT
  bits_low = mode | ((bits<<4) & 0xF0) | LCD_BACKLIGHT

  # High bits
  bus.write_byte(I2C_ADDR, bits_high)
  lcd_toggle_enable(bits_high)

  # Low bits
  bus.write_byte(I2C_ADDR, bits_low)
  lcd_toggle_enable(bits_low)

def lcd_toggle_enable(bits):
  # Toggle enable
  time.sleep(E_DELAY)
  bus.write_byte(I2C_ADDR, (bits | ENABLE))
  time.sleep(E_PULSE)
  bus.write_byte(I2C_ADDR,(bits & ~ENABLE))
  time.sleep(E_DELAY)

def lcd_string(message,line):
  # Send string to display
  message = message.ljust(LCD_WIDTH," ")
  lcd_byte(line, LCD_CMD)
  for i in range(LCD_WIDTH):
    lcd_byte(ord(message[i]),LCD_CHR)
def main():
    lcd_init()
    pr="                    "
    lcd_string(pr,LCD_LINE_1)
    lcd_string(pr,LCD_LINE_2)
    lcd_string(pr,LCD_LINE_3)
    lcd_string(pr,LCD_LINE_4)
    #week=["M","t","W","T","F","s","S"]
    #wk=week[d.weekday()]
    #intvl=1

    while(True):
      pr="* Relay Controller *"
      lcd_string(pr,LCD_LINE_1)
      d = datetime.datetime.today()
      d1=d.strftime(">%Y/%m/%d-%H:%M:%S")
      print (d1)
      lcd_string(d1,LCD_LINE_2)
      pr="                    "
      lcd_string(pr,LCD_LINE_4)
      pr=">on1,off1,on2,off2 ?"    
      lcd_string(pr,LCD_LINE_3)
      ans=input(pr)
      lcd_string(">"+ans,LCD_LINE_4)
      if ans=="on1":   
        GPIO.output(RELAY1,GPIO.HIGH)
      elif ans=="off1":
        GPIO.output(RELAY1,GPIO.LOW)
      elif ans=="on2":
        GPIO.output(RELAY2,GPIO.HIGH)
      elif ans=="off2":
        GPIO.output(RELAY2,GPIO.LOW)
      else:
        time.sleep(2)
        pr=">Invalid Command"
        print(pr)
        lcd_string(pr,LCD_LINE_4)
      
        
if __name__ == '__main__':
    try:
      main()
    except KeyboardInterrupt:
      pass

